/**************************************************************************
***    
***    Copyright (c) 1995-1997 by ABKGroup, UCLA VLSI CAD Laboratory,
***    UCLA Computer Science Department, Los Angeles, CA 90095-1596 USA, 
***    and by the Regents of the University of California.    
***    All rights reserved.   
***
***    No portion of this file may be used, copied, or transmitted for
***    any purpose, including any research or commercial purpose,
***    without the express written consent of Professor Andrew B. Kahng,
***    UCLA Computer Science Department, 3713 Boelter Hall, Los Angeles,
***    CA 90095-1596 USA.   Any copy made of this file must include this
***    notice.    ABKGroup and the Regents of the University of California
***    retain title to all copies of this file and/or its compiled
***    derivatives.
***
***************************************************************************/
//! author="Igor Markov, July 15, 1997"
//! CHANGES="plGeom.h 971113 mro unified unseeded, seeded ctors in RandomPoint 971205 ilm added BBox::ShrinkTo(double percent=0.9) with percent>0; percent > 1.0 will expand the BBox"


/* Last revision::    Igor Markov, July 15, 1997
 971113 mro unified unseeded, seeded ctors in RandomPoint
 971205 ilm added BBox::ShrinkTo(double percent=0.9)
             with percent>0; percent > 1.0 will expand the BBox
*/
///
#ifndef _PLGEOM_H_
#define _PLGEOM_H_

class Point;
class BBox;
typedef BBox Rectangle;
class RandomPoint;    
class SmartBBox;

#include "point.h"
#include "bbox.h"

//: Generates a radom point in a given BBox
class RandomPoint
{
   RandomDouble _xGen;
   RandomDouble _yGen;
public:
   RandomPoint(const BBox& bb, unsigned xSeed=UINT_MAX, unsigned ySeed=UINT_MAX)
                                : _xGen(bb.xMin,bb.xMax,xSeed),
                                  _yGen(bb.yMin,bb.yMax,ySeed) {};
   unsigned getXSeed() { return _xGen.getSeed(); }
   unsigned getYSeed() { return _yGen.getSeed(); }

   operator Point()    { return Point(_xGen,_yGen); }
};

#endif
