/**************************************************************************
***
***    Copyright (c) 1995-1998 by ABKGroup, UCLA VLSI CAD Laboratory,
***    UCLA Computer Science Department, Los Angeles, CA 90095-1596 USA,
***    and by the Regents of the University of California.
***    All rights reserved.
***
***    No portion of this file may be used, copied, or transmitted for
***    any purpose, including any research or commercial purpose,
***    without the express written consent of Professor Andrew B. Kahng,
***    UCLA Computer Science Department, 3713 Boelter Hall, Los Angeles,
***    CA 90095-1596 USA.   Any copy made of this file must include this
***    notice.    ABKGroup and the Regents of the University of California
***    retain title to all copies of this file and/or its compiled
***    derivatives.
***
***************************************************************************/

#include "subHGForCapo.h"


SubHGraphForCapo::SubHGraphForCapo(
	unsigned 		numTerminals,
	unsigned 		numNonTerms,
	unsigned		edgeBound)

     	: SubHGraph(numTerminals, numNonTerms, edgeBound)

{
    _nodeNames = vector<const char*>(numTerminals+numNonTerms, 
						static_cast<const char*>(NULL));
    _nodes[0]->setWeight(0);
    _nodes[1]->setWeight(0);	//they aren't mapped, as they
				//are 'conglomerate' nodes
    char* termName;
    termName = new char[7];
    strcpy(termName, "term0");
    _nodeNames[0] = termName;
    _namesMap[termName] = 0;

    termName = new char[7];
    strcpy(termName, "term1");
    _nodeNames[1] = termName;
    _namesMap[termName] = 1;

}

